/* written - v0.0.5 - MIT */
/* Written provides a set of utilities for manipulating text, with a focus on providing typographic tools rather than pure string manipulation. */
/* https://github.com/stephenhutchings/written.git */
!function(a,b){"function"==typeof define&&define.amd?define([],b):"object"==typeof exports?module.exports=b():a.written=b()}(this,function(){var a,b;return a=/[-_\s]+|(!?[A-Z][a-z]*)/g,b={numbers:{EN:["one","two","three","four","five","six","seven","eight","nine","ten","eleven","twelve"],FR:[{m:"un",f:"une"},"deux","trois","quatre","cinq","six","sept","huit","neuf","dix","onze","douze"],DE:["eins","zwei","drei","vier","fünf","sechs","sieben","acht","neun","zehn","elf","zwölf"],IT:[{m:"uno",f:"una"},"due","tre","quattro","cinque","sei","sette","otto","nove","dieci","undici","dodic"],ES:[{m:"uno",f:"una"},"dos","tres","cuatro","cinco","seis","siete","ocho","nueve","diez","once","doce"],SE:[{m:"ett",n:"en"},"två","tre","fyra","fem","sex","sju","åtta","nio","tio","elva","tolv"]},noncaps:{EN:/^(an|and|as|at|be|but|by|has|in|if|nor|of|off|on|or|out|per|the|to|up|was)$/},capitalize:function(a){return a.charAt(0).toUpperCase()+a.slice(1)},capitalizeAll:function(a,c){var d,e;return null==c&&(c=b.noncaps.EN),"[object RegExp]"!==toString.call(c)&&(c=b.noncaps[c]),function(){var f,g,h,i;for(h=a.split(/\s/g),i=[],d=f=0,g=h.length;g>f;d=++f)e=h[d],d>0&&c.test(e)?i.push(e):i.push(b.capitalize(e));return i}().join(" ")},cleanJoin:function(a,b){var c;return null==b&&(b=""),function(){var b,d,e;for(e=[],b=0,d=a.length;d>b;b++)c=a[b],c&&"string"==typeof c&&e.push(c);return e}().join(b)},collapse:function(a){return a.replace(/\s+/g," ")},camelCase:function(c){var d,e;return b.cleanJoin(function(){var f,g,h,i;for(h=c.split(a),i=[],d=f=0,g=h.length;g>f;d=++f)e=h[d],e&&(0===d?i.push(e):i.push(b.capitalize(e)));return i}()),c.replace(/[\s_-]+(\w)/g,function(a,b){return b.toUpperCase()})},hyphenCase:function(c,d){return(d?"-":"")+b.cleanJoin(c.split(a),"-").toLowerCase()},snakeCase:function(c){return b.cleanJoin(c.split(a),"_").toLowerCase()},humanCase:function(c){return b.cleanJoin(c.split(a)," ")},wrapInTag:function(a,b){return null==b&&(b="span"),"<"+b+">"+a+"</"+b+">"},prettyList:function(a,c,d){var e,f,g,h,i,j;return null==d&&(d={}),h=d.more||"more",e=d.amp||"and",d.key&&(a=function(){var b,c,e;for(e=[],b=0,c=a.length;c>b;b++)i=a[b],"object"==typeof i&&e.push(i[d.key]);return e}()),d.wrap&&(a=function(){var c,e,f;for(f=[],c=0,e=a.length;e>c;c++)j=a[c],f.push(b.wrapInTag(j,d.wrap));return f}()),c<(g=a.length)&&(f=g-c,d.quantify&&(h=b.quantify(h,f,{numberless:!0})),d.written&&(f=b.writtenNumber(f,d.lang)),a=a.slice(0,c),a=a.concat(f+" "+h)),a.slice(0,-1).join(", ").concat(1===a.length?"":" "+e+" ",a.slice(-1))},hyphenate:function(a,b,c){return null==a&&(a=""),null==b&&(b=10),null==c&&(c="­"),a.replace(new RegExp("\\w{"+b+"}","g"),function(a){return a+c})},quantify:function(a,c,d){var e,f,g,h,i,j,k;return h=null!=d?d:{},f=h.numberless,k=h.written,e=h.lang,g=h.plural,"string"!=typeof a&&(i={str:c,n:a},c=i.n,a=i.str),j=1===c?"":"s",k&&(c=b.writtenNumber(c,e)),c=f?"":c+" ",c+(g||a+j)},writtenNumber:function(a,b,c){var d;return null==b&&(b="EN"),null==c&&(c="m"),a-1<this.numbers[b].length?(d=this.numbers[b][a-1],d[c]&&d[c]||d):a},setNumbers:function(a,b){return this.numbers[b]=a},setNonCaps:function(a,b){return this.noncaps[b]=a}},b.dasherize=b.dashify=b.hyphenCase,b.slugify=b.underscore=b.snakeCase,b.numerate=b.count=b.quantify,b.titleCase=b.capitalizeAll,b});